
#include <stdio.h>

#define MAXHISTORY  20
#define ARRPOS      (current_pos % MAXHISTORY)

#define xmalloc(XX) malloc(XX)
#define xfree(XX)   free(XX);

struct history {
  int  pos;
  char *string;
};

int current_pos = -1;


struct history history_list[MAXHISTORY];


void add_history(str)
     char *str;
{
  current_pos += 1;
  if(current_pos >= MAXHISTORY) {
    history_list[ARRPOS].pos = current_pos;
    if(history_list[ARRPOS].string)
      xfree(history_list[ARRPOS].string);
  }
  history_list[ARRPOS].string = (char *) xmalloc(strlen(str) + 1);
  strcpy(history_list[ARRPOS].string, str);
}

char *lookup_history(pos)
     int pos;
{
  if(pos > current_pos || pos <= current_pos - MAXHISTORY || pos < 0)
    return NULL;
  return history_list[ARRPOS].string;
}

void print_history()
{
  int i;
  
  if(current_pos < MAXHISTORY)
    i = 0;
  else 
    i = current_pos - MAXHISTORY + 1;
  for(; i <= current_pos; i++)
    printf("%3d. %s\n", i % MAXHISTORY, history_list[i % MAXHISTORY].string);
}


main()
{
  char buff[100];
  
  while(*gets(buff) != 'q') {
    if(*buff == '!')
      printf("[%d] %s\n", current_pos, lookup_history(current_pos));
    else if(*buff == '%')
      print_history();
    else
      add_history(buff);
  }
}

	   
  
